<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" version="1.0" encoding="windows-1251" indent="yes"/>
	<xsl:variable name="unitname">
		<xsl:value-of select="namespace/@name"/>
	</xsl:variable>
	<!-- Перевод текста похожего на html в html -->
	<xsl:template match="*" mode="htm">
		<xsl:choose>
			<xsl:when test="translate(name(), 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')='PARA'">
				<xsl:if test="./node()">
					<p>
						<xsl:attribute name="id"><xsl:value-of select="name()"/></xsl:attribute>
						<xsl:copy-of select="./node()"/>
					</p>
				</xsl:if>
			</xsl:when>
			<xsl:when test="translate(name(), 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')='NOTE'">
				<xsl:if test="./node()">
					<xsl:choose>
						<xsl:when test="@type='note'">
							<div>
								<xsl:attribute name="id"><xsl:value-of select="'note'"/></xsl:attribute>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</div>
						</xsl:when>
						<xsl:when test="@type='warning'">
							<div>
								<xsl:attribute name="id"><xsl:value-of select="@type"/></xsl:attribute>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</div>
						</xsl:when>
						<xsl:when test="@type='caution'">
							<div>
								<xsl:attribute name="id"><xsl:value-of select="@type"/></xsl:attribute>
								<h4>Ахтунг</h4>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</div>
						</xsl:when>
						<xsl:when test="@type='important'">
							<div>
								<xsl:attribute name="id"><xsl:value-of select="@type"/></xsl:attribute>
								<h4>Важная инфа</h4>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</div>
						</xsl:when>
						<xsl:when test="@type='tip'">
							<div>
								<xsl:attribute name="id"><xsl:value-of select="@type"/></xsl:attribute>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</div>
						</xsl:when>
						<xsl:when test="@type='security'">
							<div>
								<xsl:attribute name="id"><xsl:value-of select="@type"/></xsl:attribute>
								<h4>Для служебного пользования</h4>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</div>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy-of select="./node()"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
			</xsl:when>
			<xsl:when test="translate(name(), 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')='SEE'">
				<xsl:if test="@href">
					<A>
						<xsl:attribute name="id"><xsl:value-of select="name()"/></xsl:attribute>
						<xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
						<xsl:choose>
							<xsl:when test="./node()">
								<xsl:copy-of select="./node()"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="@href"/>
							</xsl:otherwise>
						</xsl:choose>
					</A>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy-of select="."/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--алсо-->
	<xsl:template name="seealso">
		<xsl:param name="classname"/>
		<xsl:param name="style"/>
		<!-- После : -->
		<xsl:variable name="cref2">
			<xsl:value-of select="substring-after(@cref, ':')"/>
		</xsl:variable>
		<!-- Между : и ( -->
		<xsl:variable name="cref1">
			<xsl:choose>
				<xsl:when test="substring-before($cref2, '(')">
					<xsl:value-of select="substring-before($cref2, '(')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$cref2"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- До первой точки -->
		<xsl:variable name="part1">
			<xsl:value-of select="substring-before($cref1, '.')"/>
		</xsl:variable>
		<!-- После первой точки -->
		<xsl:variable name="part2tmp">
			<xsl:value-of select="substring-after($cref1, '.')"/>
		</xsl:variable>
		<!-- После второй точки -->
		<xsl:variable name="part3tmp">
			<xsl:value-of select="substring-after(substring-after($cref1, '.'), '.')"/>
		</xsl:variable>
		<xsl:variable name="part2">
			<xsl:choose>
				<xsl:when test="substring-before($part2tmp, '(')">
					<xsl:value-of select="substring-before($part2tmp, '(')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="substring-before($part2tmp, '.')">
							<xsl:value-of select="substring-before($part2tmp, '.')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$part2tmp"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="part3">
			<xsl:choose>
				<xsl:when test="substring-before($part3tmp, '(')">
					<xsl:value-of select="substring-before($part3tmp, '(')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$part3tmp"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="curclassname">
			<xsl:choose>
				<xsl:when test="string-length($part3)>0">
					<xsl:value-of select="$part2"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="''"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="membname">
			<xsl:choose>
				<xsl:when test="string-length($part3)>0">
					<xsl:value-of select="$part3"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$part2"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="modulename">
			<xsl:choose>
				<xsl:when test="translate($part1, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')=translate($unitname, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')">
					<xsl:value-of select="''"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$part1"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="link">
			<xsl:if test="string-length($modulename)>0">
				<xsl:value-of select="$modulename"/>
				<xsl:text>.html</xsl:text>
			</xsl:if>
			<xsl:text>#Anchor-</xsl:text>
			<xsl:if test="string-length($curclassname)">
				<xsl:value-of select="$curclassname"/>
				<xsl:text>-</xsl:text>
			</xsl:if>
			<xsl:if test="string-length($membname)">
				<xsl:value-of select="$membname"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="title">
			<xsl:if test="string-length($modulename)>0">
				<xsl:value-of select="$modulename"/>
				<xsl:text>.</xsl:text>
			</xsl:if>
			<xsl:if test="string-length($curclassname)">
				<xsl:choose>
					<xsl:when test="translate($curclassname, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')=translate($classname, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')">
						<xsl:value-of select="''"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$curclassname"/>
						<xsl:text>.</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
			<xsl:if test="string-length($membname)">
				<xsl:value-of select="$membname"/>
			</xsl:if>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$style=1">
				<a>
					<xsl:attribute name="id"><xsl:value-of select="name()"/></xsl:attribute>
					<xsl:attribute name="href"><xsl:value-of select="$link"/></xsl:attribute>
					<xsl:choose>
						<xsl:when test="./node()">
							<xsl:attribute name="title"><xsl:value-of select="$title"/></xsl:attribute>
							<xsl:apply-templates select="./node()" mode="htm"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$title"/>
						</xsl:otherwise>
					</xsl:choose>
				</a>
			</xsl:when>
			<xsl:otherwise>
				<tr>
					<td width="250">
						<a>
							<xsl:attribute name="id"><xsl:value-of select="name()"/></xsl:attribute>
							<xsl:attribute name="href"><xsl:value-of select="$link"/></xsl:attribute>
							<xsl:value-of select="$title"/>
						</a>
					</td>
					<xsl:if test="./node()">
						<td>
							<xsl:apply-templates select="./node()" mode="htm"/>
						</td>
					</xsl:if>
				</tr>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--remarks-->
	<xsl:template match="remarks">
		<xsl:if test=".">
			<H4>
				<xsl:text>Замечания</xsl:text>
			</H4>
			<div id="DEV">
				<!--<xsl:copy-of select="."/>-->
				<xsl:apply-templates select="./node()" mode="htm"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--permission-->
	<xsl:template match="permission">
		<xsl:if test=".">
			<H4>
				<xsl:text>Допущения</xsl:text>
			</H4>
			<div id="DEV">
				<xsl:apply-templates select="./node()" mode="htm"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--summary-->
	<xsl:template match="summary">
		<xsl:if test=".">
			<div id="DEV">
				<xsl:apply-templates select="./node()" mode="htm"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--comments-->
	<xsl:template match="comments">
		<xsl:if test=".">
			<H4>
				<xsl:text>Комменты</xsl:text>
			</H4>
			<div id="DEV">
				<xsl:apply-templates select="./node()" mode="htm"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--param-->
	<xsl:template match="param">
		<tr>
			<td width="250">
				<xsl:value-of select="@name"/>
			</td>
			<td>
				<xsl:apply-templates select="./node()" mode="htm"/>
			</td>
		</tr>
	</xsl:template>
	<!--example-->
	<xsl:template match="example">
		<xsl:if test=".">
			<H4>
				<xsl:text>Пример использования</xsl:text>
			</H4>
			<div id="EXAMPLE">
				<code>
					<xsl:apply-templates select="./node()" mode="htm"/>
				</code>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Формирует якорь-->
	<xsl:template name="anchor">
		<xsl:param name="classname"/>
		<a>
			<xsl:attribute name="name"><xsl:text>Anchor-</xsl:text><xsl:if test="string-length($classname) > 0"><xsl:value-of select="$classname"/><xsl:text>-</xsl:text></xsl:if><xsl:value-of select="@name"/></xsl:attribute>
		</a>
	</xsl:template>
	<!--Формирует текст из описания-->
	<xsl:template name="dev">
		<xsl:param name="classname"/>
		<xsl:for-each select="devnotes">
			<xsl:apply-templates select="summary"/>
			<xsl:apply-templates select="permission"/>
			<xsl:if test="exception">
				<H4>
					<xsl:text>Исключения</xsl:text>
				</H4>
				<table id="param" width="90%">
					<xsl:for-each select="exception">
						<xsl:call-template name="seealso">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:for-each>
				</table>
			</xsl:if>
			<xsl:apply-templates select="remarks"/>
			<xsl:if test="param|returns">
				<H4>
					<xsl:text>Параметры</xsl:text>
				</H4>
				<table id="param" width="90%">
					<xsl:apply-templates select="param"/>
					<xsl:for-each select="returns">
						<tr>
							<td width="250">
								<xsl:value-of select="'Возвращаемое значение'"/>
							</td>
							<td>
								<xsl:apply-templates select="./node()" mode="htm"/>
							</td>
						</tr>
					</xsl:for-each>
				</table>
			</xsl:if>
			<xsl:apply-templates select="example"/>
			<xsl:apply-templates select="comments"/>
			<xsl:if test="seealso">
				<H4>
					<xsl:text>См. также</xsl:text>
				</H4>
				<div id="DEV">
					<xsl:for-each select="seealso">
						<xsl:call-template name="seealso">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
							<xsl:with-param name="style">
								1
						</xsl:with-param>
						</xsl:call-template>
						<xsl:if test="not(position()=last())">
							<xsl:text>, </xsl:text>
						</xsl:if>
					</xsl:for-each>
				</div>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!--Const-->
	<xsl:template match="const">
		<xsl:if test="devnotes">
			<div id="PART">
				<H3>
					<xsl:choose>
						<xsl:when test="@resourcestring='true'">
							<xsl:attribute name="id"><xsl:text>pin_green</xsl:text></xsl:attribute>
						</xsl:when>
						<xsl:when test="@type">
							<xsl:attribute name="id"><xsl:text>pin_blue</xsl:text></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="id"><xsl:text>pin_grey</xsl:text></xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:value-of select="@name"/>
					<xsl:call-template name="anchor">
					</xsl:call-template>
				</H3>
				<xsl:if test="value">
					<div id="VAL">
						<xsl:value-of select="value"/>
					</div>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="@resourcestring='true'">
						<H4>
							<xsl:text>ресурсная строка</xsl:text>
						</H4>
					</xsl:when>
					<xsl:when test="@type">
						<H4>
							<xsl:text>тип константы</xsl:text>
						</H4>
						<div id="DEV">
							<xsl:value-of select="@type"/>
						</div>
					</xsl:when>
					<xsl:otherwise>
						<H4>
							<xsl:text>нетипизованная константа</xsl:text>
						</H4>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="dev"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Stuct-->
	<xsl:template match="struct">
		<xsl:if test="devnotes">
			<div id="PART">
				<H3>
					<xsl:attribute name="id"><xsl:text>box_white</xsl:text></xsl:attribute>
					<xsl:value-of select="@name"/>
					<xsl:call-template name="anchor">
					</xsl:call-template>
				</H3>
				<div id="VAL">
					<xsl:value-of select="@name"/>
					<xsl:text> = </xsl:text>
					<xsl:if test="@packed='true'">
						<xsl:text> packed </xsl:text>
					</xsl:if>
					<xsl:text> record </xsl:text>
					<xsl:if test="field">
						<xsl:for-each select="field">
							<br/>&#160;
									<xsl:value-of select="@name"/>
							<xsl:if test="@type">
								<xsl:text>: </xsl:text>
								<xsl:value-of select="@type"/>
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:for-each>
						<br/>
						<xsl:text>end</xsl:text>
					</xsl:if>
				</div>
				<xsl:call-template name="dev"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Enum-->
	<xsl:template match="enum">
		<xsl:if test="devnotes">
			<div id="PART">
				<H3>
					<xsl:attribute name="id"><xsl:text>enum</xsl:text></xsl:attribute>
					<xsl:value-of select="@name"/>
					<xsl:call-template name="anchor">
					</xsl:call-template>
				</H3>
				<div id="VAL">
					<xsl:if test="element">
						<xsl:value-of select="@name"/>
						<xsl:text> = (</xsl:text>
						<xsl:for-each select="element">
							<xsl:value-of select="@name"/>
							<xsl:if test="not(position()=last())">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
					</xsl:if>
				</div>
				<xsl:call-template name="dev"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Set-->
	<xsl:template match="set">
		<xsl:if test="devnotes">
			<div id="PART">
				<H3>
					<xsl:attribute name="id"><xsl:text>set</xsl:text></xsl:attribute>
					<xsl:value-of select="@name"/>
					<xsl:call-template name="anchor">
						<!--<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>-->
					</xsl:call-template>
				</H3>
				<div id="VAL">
					<xsl:if test="@type">
						<xsl:value-of select="@name"/>
						<xsl:text> = set of </xsl:text>
						<xsl:value-of select="@type"/>
					</xsl:if>
				</div>
				<xsl:call-template name="dev"/>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Добавление модуля и класса предка в таблицу предков-->
	<xsl:template name="CLASSNAME">
		<td width="40%">
			<xsl:if test="@namespace">
				<xsl:value-of select="@namespace"/>
			</xsl:if>
		</td>
		<td>
			<xsl:value-of select="@name"/>
		</td>
	</xsl:template>
	<!--Добавление строки в таблицу наследований-->
	<xsl:template match="ancestor">
		<tr>
			<xsl:call-template name="CLASSNAME"/>
			<xsl:apply-templates select="ancestor"/>
		</tr>
	</xsl:template>
	<!--информация о поле-->
	<xsl:template match="field">
		<xsl:param name="classname"/>
		<xsl:if test="devnotes">
			<div id="MEMB">
				<xsl:variable name="imgname">Img<xsl:value-of select="$classname"/>
					<xsl:value-of select="@name"/>
				</xsl:variable>
				<xsl:variable name="txtname">Val<xsl:value-of select="$classname"/>
					<xsl:value-of select="@name"/>
				</xsl:variable>
				<H3>
					<xsl:attribute name="id"><xsl:text>field</xsl:text></xsl:attribute>
					<img>
						<xsl:attribute name="src">img/<xsl:value-of select="@visibility"/>.png</xsl:attribute>
						<xsl:attribute name="width">30</xsl:attribute>
						<xsl:attribute name="height">24</xsl:attribute>
						<xsl:attribute name="border">0</xsl:attribute>
						<xsl:attribute name="alt"><xsl:value-of select="@visibility"/> field</xsl:attribute>
					</img>
					<xsl:if test="string-length($classname)>0">
						<xsl:value-of select="$classname"/>
						<xsl:text>.</xsl:text>
						<xsl:call-template name="anchor">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:if>
					<xsl:value-of select="@name"/>
				</H3>
				<a>
					<xsl:attribute name="onClick">ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')</xsl:attribute>
					<img>
						<xsl:attribute name="src">img/hide.png</xsl:attribute>
						<xsl:attribute name="width">8</xsl:attribute>
						<xsl:attribute name="height">8</xsl:attribute>
						<xsl:attribute name="name"><xsl:value-of select="$imgname"/></xsl:attribute>
						<xsl:attribute name="title">Скрыть/отобразить часть текста</xsl:attribute>
					</img>
				</a>
				<a>
					<xsl:attribute name="name"><xsl:value-of select="$txtname"/></xsl:attribute>
					<div>
						<xsl:attribute name="id">VAL</xsl:attribute>
						<xsl:value-of select="@visibility"/>
						<br/>
						<xsl:text>&#160;&#160;</xsl:text>
						<xsl:value-of select="@name"/>
						<xsl:if test="@type">: <xsl:value-of select="@type"/>
						</xsl:if>
					</div>
				</a>
				<script type="text/javascript">
					ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')
				</script>
				<xsl:call-template name="dev">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
				</xsl:call-template>
			</div>
		</xsl:if>
	</xsl:template>
	<!--информация о свойстве-->
	<xsl:template match="property">
		<xsl:param name="classname"/>
		<xsl:if test="devnotes">
			<div id="MEMB">
				<xsl:variable name="imgname">Img<xsl:value-of select="$classname"/>
					<xsl:value-of select="@name"/>
				</xsl:variable>
				<xsl:variable name="txtname">Val<xsl:value-of select="$classname"/>
					<xsl:value-of select="@name"/>
				</xsl:variable>
				<H3>
					<xsl:attribute name="id"><xsl:text>property</xsl:text><xsl:if test="@read">get</xsl:if><xsl:if test="@write">set</xsl:if></xsl:attribute>
					<img>
						<xsl:attribute name="src">img/<xsl:value-of select="@visibility"/>.png</xsl:attribute>
						<xsl:attribute name="width">30</xsl:attribute>
						<xsl:attribute name="height">24</xsl:attribute>
						<xsl:attribute name="border">0</xsl:attribute>
						<xsl:attribute name="alt"><xsl:value-of select="@visibility"/> property<xsl:if test="@read"> read</xsl:if><xsl:if test="@write"> write</xsl:if></xsl:attribute>
					</img>
					<xsl:if test="string-length($classname)>0">
						<xsl:value-of select="$classname"/>
						<xsl:text>.</xsl:text>
						<xsl:call-template name="anchor">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:if>
					<xsl:value-of select="@name"/>
				</H3>
				<a>
					<xsl:attribute name="onClick">ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')</xsl:attribute>
					<img>
						<xsl:attribute name="src">img/hide.png</xsl:attribute>
						<xsl:attribute name="width">8</xsl:attribute>
						<xsl:attribute name="height">8</xsl:attribute>
						<xsl:attribute name="name"><xsl:value-of select="$imgname"/></xsl:attribute>
						<xsl:attribute name="title">Скрыть/отобразить часть текста</xsl:attribute>
					</img>
				</a>
				<a>
					<xsl:attribute name="name"><xsl:value-of select="$txtname"/></xsl:attribute>
					<div>
						<xsl:attribute name="id">VAL</xsl:attribute>
						<xsl:value-of select="@visibility"/>
						<br/>
						<xsl:text>&#160;&#160;</xsl:text>
						<b>property</b>
						<xsl:text> </xsl:text>
						<xsl:value-of select="@name"/>
						<xsl:if test="@type">: <xsl:value-of select="@type"/>
						</xsl:if>
						<xsl:if test="@read">
							<xsl:text> </xsl:text>
							<b>read</b>
							<xsl:text> </xsl:text>
							<xsl:value-of select="@read"/>
						</xsl:if>
						<xsl:if test="@write">
							<xsl:text> </xsl:text>
							<b>write</b>
							<xsl:text> </xsl:text>
							<xsl:value-of select="@write"/>
						</xsl:if>
						<xsl:if test="@default">
							<xsl:if test="@default!='0'">
								<xsl:text> </xsl:text>
								<b>default</b>
								<xsl:text> </xsl:text>
								<xsl:value-of select="@default"/>
							</xsl:if>
						</xsl:if>
					</div>
				</a>
				<script type="text/javascript">
					ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')
				</script>
				<xsl:call-template name="dev">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
				</xsl:call-template>
			</div>
		</xsl:if>
	</xsl:template>
	<!--	
    	Декларация метода
-->
	<xsl:template name="varMETHOD">
		<xsl:param name="classname"/>
		<xsl:param name="kind"/>
		<xsl:variable name="imgname">Img<xsl:value-of select="$classname"/>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:variable name="txtname">Val<xsl:value-of select="$classname"/>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<H3>
			<xsl:attribute name="id"><xsl:value-of select="$kind"/></xsl:attribute>
			<img>
				<xsl:attribute name="src">img/<xsl:value-of select="@visibility"/>.png</xsl:attribute>
				<xsl:attribute name="width">30</xsl:attribute>
				<xsl:attribute name="height">24</xsl:attribute>
				<xsl:attribute name="border">0</xsl:attribute>
				<xsl:attribute name="alt"><xsl:value-of select="@visibility"/><xsl:text> </xsl:text><xsl:value-of select="$kind"/></xsl:attribute>
			</img>
			<xsl:call-template name="anchor">
				<xsl:with-param name="classname">
					<xsl:value-of select="$classname"/>
				</xsl:with-param>
			</xsl:call-template>
			<xsl:if test="string-length($classname)>0">
				<xsl:value-of select="$classname"/>
				<xsl:text>.</xsl:text>
			</xsl:if>
			<xsl:value-of select="@name"/>
		</H3>
		<a>
			<xsl:attribute name="onClick">ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')</xsl:attribute>
			<img>
				<xsl:attribute name="src">img/hide.png</xsl:attribute>
				<xsl:attribute name="width">8</xsl:attribute>
				<xsl:attribute name="height">8</xsl:attribute>
				<xsl:attribute name="name"><xsl:value-of select="$imgname"/></xsl:attribute>
				<xsl:attribute name="title">Скрыть/отобразить часть текста</xsl:attribute>
			</img>
		</a>
		<a>
			<xsl:attribute name="name"><xsl:value-of select="$txtname"/></xsl:attribute>
			<div>
				<xsl:attribute name="id">VAL</xsl:attribute>
				<xsl:if test="string-length($classname)>0">
					<xsl:value-of select="@visibility"/>
					<br/>
					<xsl:text>&#160;&#160;</xsl:text>
				</xsl:if>
				<xsl:if test="substring(@procflags, 1, 5)='class'">
					<b>
						<xsl:text>class </xsl:text>
					</b>
				</xsl:if>
				<b>
					<xsl:value-of select="$kind"/>
				</b>
				<xsl:text> </xsl:text>
				<xsl:value-of select="@name"/>
				<xsl:for-each select="parameters">(<xsl:for-each select="parameter">
						<xsl:if test="last()>1">
							<br/>&#160;&#160;&#160;&#160;
						</xsl:if>
						<xsl:if test="@paramflags">
							<b>
								<xsl:choose>
									<xsl:when test="substring(@procflags, 1, 5)='class'">
										<xsl:value-of select="substring(@procflags, 6, string-length(@procflags))"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="@paramflags"/>
									</xsl:otherwise>
								</xsl:choose>
							</b>&#160;</xsl:if>
						<xsl:value-of select="@name"/>
						<xsl:if test="@type">:&#160;<xsl:value-of select="@type"/>
						</xsl:if>
						<xsl:if test="not(position()=last())">
							<xsl:text>; </xsl:text>
						</xsl:if>
						<xsl:if test="(position()=last())and(last()>1)">
							<br/>&#160;&#160;
								</xsl:if>
					</xsl:for-each>)<xsl:for-each select="retval">: <xsl:value-of select="@type"/>
					</xsl:for-each>
				</xsl:for-each>
				<xsl:choose>
					<xsl:when test="substring(@procflags, 1, 5)='class'">
						<xsl:if test="substring(@procflags, 6, string-length(@procflags))">; <b>
								<xsl:value-of select="substring(@procflags, 6, string-length(@procflags))"/>
							</b>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="@procflags">; <b>
								<xsl:value-of select="@procflags"/>
							</b>
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</div>
		</a>
		<script type="text/javascript">
					ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')
				</script>
	</xsl:template>
	<!--информация о методе-процедуре-->
	<xsl:template match="procedure">
		<xsl:param name="classname"/>
		<xsl:if test="devnotes">
			<div>
				<xsl:choose>
					<xsl:when test="string-length($classname)>0">
						<xsl:attribute name="id"><xsl:text>MEMB</xsl:text></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="id"><xsl:text>PART</xsl:text></xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="varMETHOD">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
					<xsl:with-param name="kind">
						<xsl:value-of select="'procedure'"/>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dev">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
				</xsl:call-template>
			</div>
		</xsl:if>
	</xsl:template>
	<!--информация о методе-функции-->
	<xsl:template match="function">
		<xsl:param name="classname"/>
		<xsl:if test="devnotes">
			<div>
				<xsl:choose>
					<xsl:when test="string-length($classname)>0">
						<xsl:attribute name="id"><xsl:text>MEMB</xsl:text></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="id"><xsl:text>PART</xsl:text></xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="varMETHOD">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
					<xsl:with-param name="kind">
						<xsl:value-of select="'function'"/>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dev">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
				</xsl:call-template>
			</div>
		</xsl:if>
	</xsl:template>
	<!--информация о конструкторе-->
	<xsl:template match="constructor">
		<xsl:param name="classname"/>
		<xsl:if test="devnotes">
			<div id="MEMB">
				<xsl:call-template name="varMETHOD">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
					<xsl:with-param name="kind">
						<xsl:value-of select="'constructor'"/>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dev">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
				</xsl:call-template>
			</div>
		</xsl:if>
	</xsl:template>
	<!--информация о деструкторе-->
	<xsl:template match="destructor">
		<xsl:param name="classname"/>
		<xsl:if test="devnotes">
			<div id="MEMB">
				<xsl:call-template name="varMETHOD">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
					<xsl:with-param name="kind">
						<xsl:value-of select="'destructor'"/>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dev">
					<xsl:with-param name="classname">
						<xsl:value-of select="$classname"/>
					</xsl:with-param>
				</xsl:call-template>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Variable-->
	<xsl:template match="variable">
		<xsl:variable name="imgname">
			<xsl:text>Img</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:variable name="txtname">
			<xsl:text>Val</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<div id="PART">
			<H3>
				<xsl:attribute name="id"><xsl:text>variable</xsl:text></xsl:attribute>
				<xsl:call-template name="anchor"/>
				<xsl:value-of select="@name"/>
			</H3>
			<a>
				<xsl:attribute name="onClick">ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')</xsl:attribute>
				<img>
					<xsl:attribute name="src">img/hide.png</xsl:attribute>
					<xsl:attribute name="width">8</xsl:attribute>
					<xsl:attribute name="height">8</xsl:attribute>
					<xsl:attribute name="name"><xsl:value-of select="$imgname"/></xsl:attribute>
					<xsl:attribute name="title">Скрыть/отобразить часть текста</xsl:attribute>
				</img>
			</a>
			<a>
				<xsl:attribute name="name"><xsl:value-of select="$txtname"/></xsl:attribute>
				<div>
					<xsl:attribute name="id">VAL</xsl:attribute>
					<xsl:value-of select="@name"/>
					<xsl:if test="@type">
						<xsl:text>: </xsl:text>
						<xsl:value-of select="@type"/>
					</xsl:if>
				</div>
			</a>
			<script type="text/javascript">
					ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')
				</script>
			<xsl:call-template name="dev"/>
		</div>
	</xsl:template>
	<!--ClassRef-->
	<xsl:template match="classref">
		<xsl:variable name="imgname">
			<xsl:text>Img</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:variable name="txtname">
			<xsl:text>Val</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<div id="PART">
			<H3>
				<xsl:attribute name="id"><xsl:text>classref</xsl:text></xsl:attribute>
				<xsl:call-template name="anchor"/>
				<xsl:value-of select="@name"/>
			</H3>
			<a>
				<xsl:attribute name="onClick">ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')</xsl:attribute>
				<img>
					<xsl:attribute name="src">img/hide.png</xsl:attribute>
					<xsl:attribute name="width">8</xsl:attribute>
					<xsl:attribute name="height">8</xsl:attribute>
					<xsl:attribute name="name"><xsl:value-of select="$imgname"/></xsl:attribute>
					<xsl:attribute name="title">Скрыть/отобразить часть текста</xsl:attribute>
				</img>
			</a>
			<a>
				<xsl:attribute name="name"><xsl:value-of select="$txtname"/></xsl:attribute>
				<div>
					<xsl:attribute name="id">VAL</xsl:attribute>
					<xsl:value-of select="@name"/>
					<xsl:text> = </xsl:text>
					<b>
						<xsl:text> class </xsl:text>
					</b>
					<xsl:if test="@ref">
						<b>
							<xsl:text> of </xsl:text>
						</b>
						<xsl:value-of select="@ref"/>
					</xsl:if>
				</div>
			</a>
			<script type="text/javascript">
					ShowHide('<xsl:value-of select="$imgname"/>','<xsl:value-of select="$txtname"/>')
				</script>
			<xsl:call-template name="dev"/>
		</div>
	</xsl:template>
	<!--Class-->
	<xsl:template match="class">
		<xsl:variable name="classname" select="@name"/>
		<xsl:if test="devnotes">
			<div id="PART">
				<H3>
					<xsl:attribute name="id"><xsl:text>box</xsl:text></xsl:attribute>
					<xsl:value-of select="@name"/>
					<xsl:call-template name="anchor">
					</xsl:call-template>
				</H3>
				<div id="VAL">
					<xsl:value-of select="@name"/>
					<xsl:text> = </xsl:text>
					<b>class</b>
					<xsl:if test="ancestor">
						<xsl:text>(</xsl:text>
						<xsl:for-each select="ancestor">
							<xsl:value-of select="@name"/>
							<xsl:if test="not(position()=last())">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
					</xsl:if>
				</div>
				<xsl:if test="ancestor">
					<h4>
						<xsl:text>Предки</xsl:text>
					</h4>
					<p>
						<table id="ancestor" width="400">
							<tr>
								<th>Модуль</th>
								<th>Класс</th>
							</tr>
							<xsl:apply-templates select="ancestor"/>
						</table>
					</p>
					<xsl:call-template name="dev"/>
				</xsl:if>
				<xsl:if test="members">
					<h4>
						<xsl:text>Содержимое</xsl:text>
					</h4>
					<xsl:for-each select="members">
						<xsl:apply-templates select="field">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="procedure">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="function">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="constructor">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="destructor">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:apply-templates select="property">
							<xsl:with-param name="classname">
								<xsl:value-of select="$classname"/>
							</xsl:with-param>
						</xsl:apply-templates>
					</xsl:for-each>
				</xsl:if>
			</div>
		</xsl:if>
	</xsl:template>
	<!--Всякая служебная часть html документа-->
	<xsl:template match="/">
		<html>
			<head>
				<!--<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>-->
				<xsl:element name="style">
					<xsl:attribute name="type"><xsl:text>text/css</xsl:text></xsl:attribute>
					<xsl:attribute name="media"><xsl:text>all</xsl:text></xsl:attribute>
					<xsl:text>@import "Doc.css";</xsl:text>
				</xsl:element>
				<script Language="JavaScript">
isNS4 = (document.layers) ? true : false;
isIE4 = (document.all &amp;&amp; !document.getElementById) ? true : false;
isIE5 = (document.all &amp;&amp; document.getElementById) ? true : false;
isNS6 = (!document.all &amp;&amp; document.getElementById) ? true : false;
firstload = 0;
function ShowHide(nameimg, name){
var objElement=document.all[name];
if (firstload==0)
{
firstload=1
if (!(objElement == null))
{
if(isNS4||isIE4){
  if(objElement.visibility =="visible")
	{objElement.visibility ="hidden"; if (nameimg!="") {document.all[nameimg].src="img/show.png"}}
  else
	{objElement.visibility ="visible"; if (nameimg!="") {document.all[nameimg].src="img/hide.png"}}
 }
else if (isIE5 || isNS6) {
  if(objElement.style.display!="none")
   {objElement.style.display = "none"; if (nameimg!="") {document.all[nameimg].src="img/show.png"}}
  else
   {objElement.style.display = ""; if (nameimg!="") {document.all[nameimg].src="img/hide.png"}}
}
}
firstload=0;
}
return 1;
}
				</script>
			</head>
			<body>
				<xsl:attribute name="ID"><xsl:text>allbody</xsl:text></xsl:attribute>
				<xsl:apply-templates select="namespace"/>
				<p>
					<small>©
				<a href="http://roschinspb.narod.ru/develop.html" title="http://roschinspb.narod.ru/develop.html">Полезные примочки для Delphi</a>
					</small>
				</p>
			</body>
		</html>
	</xsl:template>
	<!--Основно шаблон-->
	<xsl:template match="namespace">
		<xsl:if test="@name">
			<!--<xsl:variable name="unitname" select="@name"/>-->
			<H1>
				<xsl:attribute name="id">UNIT</xsl:attribute>
				<xsl:value-of select="$unitname"/>
			</H1>
			<xsl:call-template name="dev"/>
		</xsl:if>
		<xsl:apply-templates select="const"/>
		<xsl:apply-templates select="struct"/>
		<xsl:apply-templates select="enum"/>
		<xsl:apply-templates select="set"/>
		<xsl:apply-templates select="classref"/>
		<xsl:apply-templates select="class"/>
		<xsl:apply-templates select="variable"/>
		<xsl:apply-templates select="function">
			<xsl:with-param name="classname">
				<xsl:value-of select="''"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="procedure">
			<xsl:with-param name="classname">
				<xsl:value-of select="''"/>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
</xsl:stylesheet>
